#include "game.h"
#include "strategy.h"
#include "utility.h"
#include <ctime>



static void		Run();
static void		RunFinal();
static void		PreCompute();
static void		OutputPlan( int stage, vector<TOWER> T );



int main()
{
	int S;  cin>>S;

	if ( S == 0 )
	{
		//Run();
		RunFinal();
		return 0;
	}
	if ( S == 1 )
	{
		PreCompute();
		return 0;
	}

	//	Ȍo͐t@C
	FILE *log = fopen( "log.txt", "w" );
	SetLogFile( log );

	for ( int s=0; s<S; s++ )
	{
		vector<char> F = LoadField( cin );
		int L;  cin>>L;
		string end;  cin>>end;
		
		for ( int l=0; l<L; l++ )
		{
			int Lp, M, T, E;  cin>>Lp>>M>>T>>E;
			vector<TOWER> Tw = LoadTower( cin, T );
			vector<ENEMY> En = LoadEnemy( cin, E );
			cin>>end;

			////	
			//vector<TOWER> Tb;
			//if ( s==0 )
			//	Tb = BuildStage0( l );
			//else if ( l==0 )
			//	Tb = BuildTower( s, F, true );

			vector<TOWER> Tb = BuildTowerFinal( s, F, l, En, Lp );

			//	o
			OutputTower( cout, Tb );
		}
	}

	fclose( log );

	return 0;
}



//	JavaNCAgɎs
void Run()
{
	//	Xe[W0I_
	int		Lp	= 10;
	int		M	= 2758;

	for ( int s=1; s<80; s++ )
	{
		if ( s==40 )
			M /= 2;

		vector<char> F = LoadFieldFile( s, 2 );
		vector<vector<ENEMY> > E = LoadEnemyFile( s );
		vector<TOWER> T = BuildTower( s, F, true );

		printf( "%d-* Life:%d Money:%dX^[g܂\n", s, Lp, M );

		Simulate( s, F, T, E, &Lp, &M );

		if ( Lp <= 0 )
		{
			printf( "܂(L֥M)\n" );
			break;
		}
	}

	if ( Lp>0 )
		printf( "SʃNA(`֥L)\n" );
	
	printf( "c: %d\n", M );
	Log( "s: %.2f\n", (double)clock()/CLOCKS_PER_SEC );
}



//	JavaNCAgɎs@p
void RunFinal()
{
	int		Lp	= 10;
	int		M	= 300000;
	int		time= 0;
	//	Ȍo͐t@C
	FILE *log = fopen( "log.txt", "w" );
	SetLogFile( log );

	init_genrand(12);

	for ( int s=38; s<80; s++ )
	{
		vector<char> F = LoadFieldFile( s, 2 );
		vector<vector<ENEMY> > E = LoadEnemyFile( s );

		vector<TOWER> T;

		for ( int l=0; l<25; l++ )
		{
			clock_t start = clock();
			vector<TOWER> t = BuildTowerFinal( s, F, l, E[l], Lp );
			time += (clock()-start)*1000/CLOCKS_PER_SEC;

			printf( "%d-%d Life:%d Money:%d Time:%dX^[g܂\n", s, l, Lp, M, time );

			//for ( int i=0; i<(int)t.size(); i++ )
			//{
			//	printf( "%d %d %d %d\n", t[i].p%W, t[i].p/W, t[i].a, t[i].c );
			//}

			for ( int i=0; i<(int)t.size(); i++ )
			{
				bool f = false;
				if ( t[i].c==3 )
				{
					for ( int j=0; j<(int)T.size(); j++ )
						if ( T[j].p==t[i].p )
							T.erase(T.begin()+j), j--;
				}
				else
				{
					for ( int j=0; j<(int)T.size(); j++ )
						if ( T[j].p == t[i].p )
							T[j] = t[i],
							M -= 140,
							f = true;
					if ( !f )
						T.push_back( t[i] ),
						M -= t[i].a==0?10:150;
				}
			}

			//vector<char> f = F;
			//for ( int i=0; i<(int)T.size(); i++ )
			//	f[T[i].p]='+';
			//for ( int y=0; y<H; y++ )
			//{
			//	for ( int x=0; x<W; x++ )
			//		cout<<f[y*W+x];
			//	cout << endl;
			//}

			Simulate( 40, F, T, vector<vector<ENEMY> >(1,E[l]), &Lp, NULL );
		
			if ( Lp <= 0 )
			{
				printf( "܂(L֥M)\n" );
				goto end;
			}
		}
	}

	if ( Lp>0 )
		printf( "SʃNA(`֥L)\n" );
	
	end:;
	printf( "c: %d\n", M );
	Log( "s: %.2f\n", (double)clock()/CLOCKS_PER_SEC );
}


//	OvZ
static void	PreCompute()
{
	init_genrand(13234);

	while(true)
	{
		int firstmoney = 0;
		int secondmoney = 0;

		//for ( int stage=0; stage<40; stage++ )
		for ( int stage=40; stage<80; stage++ )
		//int stage=75;
		{
			Log( "Stage %d\n", stage );

			//	}bvƓG̓ǂݍ
			vector<char> F = LoadFieldFile( stage, 1 );
			vector<vector<ENEMY> > E = LoadEnemyFile( stage );

			//	̔zuvZ
			vector<TOWER> T = BuildTower( stage, F, false );

			//	V~[gʂ\
			int Lp = 100;
			int M = 100000000;
			Simulate( stage, F, T, E, &Lp, &M );
			Log( "Life: %+d, Money: %+d\n", Lp-100, M-100000000 );
			Lp -= 100;
			M -= 100000000;

			//	CtꂸÃt@C̔p莑҂Ȃu
			vector<TOWER> Te = LoadPlan( stage, F );
			int eLp = 100;
			int eM = 100000000;
			Simulate( stage, F, Te, E, &eLp, &eM );
			eLp -= 100;
			eM -= 100000000;

			if ( Te.empty() ||
				 Lp==0 &&	//	
				 //Lp>=-7 &&
				 M>eM )
			{
				printf( "Update %d: %d%d\n", stage, eM, M );

				//	o
				OutputPlan( stage, T );
			}
		
			if ( stage < 40 )
				firstmoney += max(M,eM);
			else
				secondmoney += max(M,eM);

			Log( "\n" );
		}

		Log( "O: %d\n", firstmoney );
		Log( "㔼: %d\n", secondmoney );
	}
}



//	o
void OutputPlan( int stage, vector<TOWER> T )
{
	char fn[256];
	sprintf( fn, FilePlan, stage );

	ofstream f(fn);
	if ( !f )
	{
		Log( "o͎s(L֥M): %d\n", stage );
		return;
	}

	int w, h;
	vector<char> F = LoadFieldFile( stage, 3, &w, &h );

	vector<string> S(h);

	for ( int y=0; y<h; y++ )
	for ( int x=0; x<w; x++ )
	{
		switch ( F[y*W+x] )
		{
		case '0': S[y] += "@"; break;
		case '1': S[y] += ""; break;
		case '2': S[y] += "H"; break;
		case 's': S[y] += ""; break;
		case 'g': S[y] += ""; break;
		default:  S[y] += "~"; break;
		}
	}

	for ( int i=0; i<(int)T.size(); i++ )
	{
		S[T[i].p/W][T[i].p%W*2  ] = "RAF"[T[i].c];
		S[T[i].p/W][T[i].p%W*2+1] = '0'+T[i].a;
	}

	for ( int y=0; y<h; y++ )
		f << S[y] << endl;

	f.close();
}

