#include "game.h"
#include "utility.h"



//	iV~[Vpj
struct TOWER2 : public TOWER
{
	int			attack;			//	U
	int			range;			//	U͈
	int			charge;			//	[d
	int			count;			//	ŌɍUĂ̎
	int			target;			//	UΏ
	vector<int>	targettime;		//	Y̓G⑫
};

//	GiV~[Vpj
struct ENEMY2 : public ENEMY
{
	int			state;			//	0: o@1: @2: S
	int			pos;			//	݈ʒu
	int			count;			//	ŌɈړĂ̎
	int			life;			//	Ct
	int			age;			//	
	int			freeze;			//	t[Y
};

bool operator<(const ENEMY2 &a, const ENEMY2 &b) { return a.t < b.t; }




//	t@C
#ifdef _MSC_VER
	//const char *FileMap		= "codevs_client_public_cert\\resource\\map\\map_%d.txt";
	//const char *FileEnemy	= "codevs_client_public_cert\\resource\\map\\enemy_%d_%d.txt";
	const char *FileMap		= "codevs_final_demo\\resource\\map\\map_%d.txt";
	const char *FileEnemy	= "codevs_final_demo\\resource\\map\\enemy_%d_%d.txt";
	const char *FilePlan	= "plan\\plan_%d.txt";
#else
	//const char *FileMap		= "codevs_client_public_cert/resource/map/map_%d.txt";
	//const char *FileEnemy	= "codevs_client_public_cert/resource/map/enemy_%d_%d.txt";
	const char *FileMap		= "codevs_final_demo/resource/map/map_%d.txt";
	const char *FileEnemy	= "codevs_final_demo/resource/map/enemy_%d_%d.txt";
	const char *FilePlan	= "plan/plan_%d.txt";
#endif

//	̃p^
static int PTowerAttack[][5] = {
	{ 10, 20, 30, 40, 50 }, 
    { 20, 40, 60, 80, 100 }, 
    { 3, 6, 9, 12, 15 } };
static int PTowerCharge[][5] = {
	{ 10, 8, 6, 4, 2 }, 
	{ 20, 18, 16, 14, 12 }, 
	{ 20, 20, 20, 20, 20 } };
static int PTowerRange[][5] = { 
	{ 4, 5, 6, 7, 8 }, 
	{ 5, 6, 7, 8, 9 }, 
	{ 2, 3, 4, 5, 6 } };
static int PTowerMoney[][5] = {
	{ 10, 20, 30, 40, 50 }, 
	{ 15, 30, 45, 60, 75 }, 
	{ 20, 40, 60, 80, 100 } };



static vector<int>	GetEnemyArrow( vector<char> F );
static void			EnemyEmerge( vector<ENEMY2> *E, int frame );
static void			EnemyMove( vector<ENEMY2> *E, vector<int> A );
static void			UpdateTowerTarget( vector<TOWER2> *T, vector<ENEMY2> E, int frame );
static int			TowerAttack( vector<TOWER2> *T, vector<ENEMY2> *E, int frame );
static int			EnemyAttack( vector<ENEMY2> *E, vector<char> F, int *rest );
static void			EnemyStep( vector<ENEMY2> *E );
static void			TowerStep( vector<TOWER2> *T );



//	tB[h̓ǂݍ
vector<char> LoadField( istream &input )
{
	vector<char> F(SZ,'1');

	int w, h;  input>>w>>h;
	for ( int y=0; y<h; y++ )
	{
		string s;  input>>s;
		for ( int x=0; x<w; x++ )
			F[y*W+x] = s[x];
	}

	return F;
}



//	̓ǂݍ
vector<TOWER> LoadTower( istream &input, int n )
{
	vector<TOWER> T(n);

	for ( int i=0; i<n; i++ )
	{
		int x, y;
		input >> x >> y >> T[i].a >> T[i].c;
		T[i].p = y*W+x;
	}

	return T;
}



//	G̓ǂݍ
vector<ENEMY> LoadEnemy( istream &input, int n )
{
	vector<ENEMY> E(n);

	for ( int i=0; i<n; i++ )
	{
		int x, y;
		input >> x >> y >> E[i].t >> E[i].l >> E[i].s;
		E[i].p = y*W+x;
	}

	return E;
}



//	̏o
void OutputTower( ostream &output, vector<TOWER> T )
{
	output << T.size() << endl;

	for ( int i=0; i<(int)T.size(); i++ )
	{
		output << T[i].p%W << " " << T[i].p/W << " "
			   << T[i].a << " " << T[i].c << endl;
	}
}



//	t@C瓃̓ǂݍ
vector<TOWER> LoadPlan( int stage, vector<char> F )
{
	vector<TOWER> T;

	char fn[256];
	sprintf( fn, FilePlan, stage );

	ifstream f(fn);
	if ( !f )
	{
		Log( "Failed to load plan: %s\n", FilePlan );
		return T;
	}

	string l;
	for ( int y=0; getline(f,l); y++ )
	{
		for ( int x=0; x<(int)l.size(); x+=2 )
		{
			int c = -1;
			switch ( l[x] )
			{
			case 'R':  c = 0;  break;
			case 'A':  c = 1;  break;
			case 'F':  c = 2;  break;
			}
			if ( c!=-1 )
				T.push_back( TOWER( x/2, y, l[x+1]-'0', c ) );

			//	H}Xɂ̓x0ĂĂ
			if ( l.substr(x,2)=="H" )
				T.push_back ( TOWER( x/2, y, 0, 0 ) );
		}
	}
	
	//	Q̂݌
	vector<TOWER> T2;

	for ( int i=0; i<(int)T.size(); i++ )
		if ( F[T[i].p]=='0' )
			T2.push_back( T[i] );

	return T2;
}



//	t@C}bv̓ǂݍ
//	random: _}Ẍ@0: 󂫂 1: ǂɁ@2: _@3: 2̂܂
vector<char> LoadFieldFile( int stage, int random, int *pw, int *ph )
{
	char fn[256];
	sprintf( fn, FileMap, stage );
	
	ifstream f(fn);
	if ( !f )
	{
		Log( "Failed to load field: %s\n", FileMap );
		return vector<char>();
	}

	int w,h,A,B;
	f>>w>>h>>A>>B;

	vector<char> F(SZ,'1');
	
	for ( int y=0; y<h; y++ )
	{
		string t;  f>>t;

		for ( int x=0; x<w; x++ )
		{
			char c = t[x];
			if ( c=='2' )
			switch ( random )
			{
			case 0:  c = '0';  break;
			case 1:  c = '1';  break;
			case 2:  c = char('0'+genrand_int31()%2);  break;
			case 3:  break;
			}
			F[y*W+x] = c;
		}
	}

	if ( pw!=NULL )  *pw = w;
	if ( ph!=NULL )  *ph = h;

	return F;
}



//	t@CG̓ǂݍ
vector<vector<ENEMY> > LoadEnemyFile( int stage )
{
	vector<vector<ENEMY> > E(25);

	for ( int i=0; i<25; i++ )
	{
		char fn[256];
		sprintf( fn, FileEnemy, stage, i );
	
		ifstream f(fn);
		if ( !f )
		{
			Log( "Failed to load enemy: %s\n", fn );
			return vector<vector<ENEMY> >();
		}

		int x, y;
		ENEMY e;
		while ( f>>x>>y>>e.t>>e.l>>e.s )
		{
			e.p = y*W+x;
			E[i].push_back(e);
		}

		//	G͍X50C
		if ( E[i].size()>50 )
			E[i].resize(50);
	}

	return E;
}



//	sʂV~[g
//	CtLpƎM͎s̏Ԃɂ
//	end^Ȃ΃Ct⎑ȂI
//	enemyrestNULLłȂ΁AG̎c胉Ct̘aԂ
void Simulate( int stage, vector<char> F, vector<TOWER> T,
			   vector<vector<ENEMY> > E, int *Lp, int *M, bool end, int *enemyrest )
{
	//	̌
	int m = GetTowerMoney( T );
	if ( M != NULL )
	{
		*M += m;
		if ( end && *M < 0 )
		{
			*Lp = 0;
			return;
		}
	}
	
	//	̈ʒuɃ}[N
	for ( int i=0; i<(int)T.size(); i++ )
		F[T[i].p] = '1';
	
	//	G̃R[XOɌvZ
	vector<int> A = GetEnemyArrow( F );

	//	
	if ( enemyrest != NULL )
		*enemyrest = 0;

	for ( int e=0; e<(int)E.size(); e++ )
	{
		//	ƓGV~[gpɕϊ
		int tn = (int)T.size();
		vector<TOWER2> tower(tn);
		int en = (int)E[e].size();
		vector<ENEMY2> enemy(en);

		for ( int i=0; i<tn; i++ )
		{
			tower[i].p = T[i].p;
			tower[i].a = T[i].a;
			tower[i].c = T[i].c;

			tower[i].attack = PTowerAttack[tower[i].c][tower[i].a];
			tower[i].range = PTowerRange[tower[i].c][tower[i].a];
			tower[i].charge = PTowerCharge[tower[i].c][tower[i].a];
			tower[i].count = tower[i].charge;
			tower[i].target = -1;
			tower[i].targettime = vector<int>(en,-1);
		}

		for ( int i=0; i<en; i++ )
		{
			enemy[i].p = E[e][i].p;
			enemy[i].t = E[e][i].t;
			enemy[i].l = E[e][i].l;
			enemy[i].s = E[e][i].s;
		
			enemy[i].state = 0;
			enemy[i].pos = enemy[i].p;
			enemy[i].count = 0;
			enemy[i].life = enemy[i].l;
			enemy[i].age = 0;
			enemy[i].freeze = 0;
		}

		//	G͏oɃ\[gĂ
		stable_sort( enemy.begin(), enemy.end() );

		//	V~[g
		for ( int f=0; ; f++ )
		{
			EnemyEmerge( &enemy, f );
			EnemyMove( &enemy, A );

			UpdateTowerTarget( &tower, enemy, f );
			int m = TowerAttack( &tower, &enemy, f );
			if ( M != NULL )
				if ( stage<40 )
					*M += m;

			int rest;
			*Lp += EnemyAttack( &enemy, F, &rest );
			if ( enemyrest != NULL )
				*enemyrest += rest;

			EnemyStep( &enemy );
			TowerStep( &tower );

			//	I
			bool fg = true;
			for ( int i=0; i<en; i++ )
				if ( enemy[i].state != 2 )
					fg = false;
			if ( fg )
				break;
		
			if ( end && *Lp <= 0 )
				break;
		}

		if ( end && *Lp <= 0 )
			break;
	}
}



//	݂ꍇ̎̕ωԂ
int GetTowerMoney( vector<TOWER> T )
{
	int m = 0;

	for ( int i=0; i<(int)T.size(); i++ )
		for ( int j=0; j<=T[i].a; j++ )
			m -= PTowerMoney[T[i].c][j];

	return m;
}



//	G̃R[X擾
//	cross^ȂΎ΂߈ړWQ}X܂
vector<int> GetEnemyCourse( vector<char> F, bool cross )
{
	vector<int> A = GetEnemyArrow( F );
	vector<int> C(SZ);

	for ( int o=0; o<SZ; o++ )
	if ( F[o]=='s' )
	{
		int p = o;
		while ( true )
		{
			C[p]++;
			if ( F[p]=='g' )
				break;
			int a = A[p];
			if ( cross && a%2!=0 )
				C[p+DirT1[a]]++,
				C[p+DirT2[a]]++;
			p += Dir[a];
		}
	}

	return C;
}



//	G̃R[X̒擾
//	Bs\ȓG0Ԃ
int GetEnemyCourseLength( vector<char> F )
{
	vector<int> A = GetEnemyArrow( F );
	if ( A.empty() )
		return 0;
	
	vector<int> dist;

	for ( int o=0; o<SZ; o++ )
	if ( F[o]=='s' )
	{
		int p = o;
		int d = 0;
		while ( true )
		{
			if ( F[p]=='g' )
				break;
			int a = A[p];
			d += 10+a%2*4;
			p += Dir[a];
		}
		dist.push_back( d );
	}

	return *min_element(dist.begin(),dist.end())*10000
		   + accumulate(dist.begin(),dist.end(),0);
}



//	pq̋̕߂
int Distance2( int p, int q )
{
	return (p%W-q%W)*(p%W-q%W)+(p/W-q/W)*(p/W-q/W);
}



//	e}X̓G̈ړ߂
vector<int> GetEnemyArrow( vector<char> F )
{
	const int		INF = SZ*3+1;
	vector<int>		D(SZ,INF);		//	
	vector<int>		A(SZ,-1);		//	
	priority_queue<pair<int,int> > Q;
	vector<bool>	fx(SZ);
	int				sn = 0;

	for ( int i=0; i<SZ; i++ )
	{
		if ( F[i]=='g' )
			Q.push( make_pair(0,i) ),
			D[i] = 0;
		if ( F[i]=='s' )
			sn++;
	}

	while ( !Q.empty() && sn>0 )
	{
		int o = Q.top().second;
		Q.pop();

		if ( !fx[o] )
		{
			for ( int d=0; d<8; d++ )
			{
				int t = o+Dir[d];
				int l = 2+d%2;

				if ( F[t]!='1' && F[o+DirT1[d]]!='1' && F[o+DirT2[d]]!='1' )
				{
					if ( D[t] > D[o]+l )
					{
						D[t] = D[o]+l;
						A[t] = (d+4)%8;
						Q.push( make_pair(-D[t],t) );
					}
					else if ( D[t] == D[o]+l )
					{
						if ( A[t] > (d+4)%8 )
							A[t] = (d+4)%8;
					}
				}
			}
			fx[o] = true;
			if ( F[o]=='s' )
				sn--;
		}
	}

	return sn==0 ? A : vector<int>();
}



//	G̔
void EnemyEmerge( vector<ENEMY2> *E, int frame )
{
	for ( int i=0; i<(int)E->size(); i++ )
		if ( (*E)[i].t==frame )
			(*E)[i].state = 1;
}



//	G̈ړ
void EnemyMove( vector<ENEMY2> *E, vector<int> A )
{
	for ( int i=0; i<(int)E->size(); i++ )
	if ( (*E)[i].state == 1 )
	{
		ENEMY2 &e = (*E)[i];

		int a = A[e.pos];
		int w = a%2==0 ? e.s : e.s*14/10;
		if ( e.count >= w )
		{
			e.pos += Dir[a];
			e.count = 0;
		}
	}
}



//	GɌ
void UpdateTowerTarget( vector<TOWER2> *T, vector<ENEMY2> E, int frame )
{
	for ( int i=0; i<(int)T->size(); i++ )
		(*T)[i].target = -1;

	for ( int j=0; j<(int)E.size(); j++ )
	if ( E[j].state==1 )
	{
		for ( int i=0; i<(int)T->size(); i++ )
		{
			TOWER2 &t = (*T)[i];

			if ( Distance2(t.p,E[j].pos) <= t.range*t.range )
			{
				if ( t.targettime[j]==-1 )
					t.targettime[j] = frame;

				if ( t.target == -1 ||
					 t.targettime[t.target] > t.targettime[j] )
					t.target = j;
			}
			else
			{
				t.targettime[j] = -1;
			}
		}
	}
}



//	̍U
//	̕ωԂ
int TowerAttack( vector<TOWER2> *T, vector<ENEMY2> *E, int frame )
{
	int M = 0;

	for ( int i=0; i<(int)T->size(); i++ )
	{
		TOWER2 &t = (*T)[i];

		if ( t.count>t.charge && t.target!=-1 )
		{
			ENEMY2 &e = (*E)[t.target];

			if ( e.state==1 )
			{
				e.life -= t.attack;
				if ( t.c==2 )
					e.freeze += 2;

				if ( e.life <= 0 )
				{
					e.state = 2;
					if ( e.l-e.age > 0 )
						M += (e.l-e.age)/10;
				}
			}

			t.count = 0;
		}
	}

	return M;
}

					

//	G̍U
//	Ct̕ωԂ
int EnemyAttack( vector<ENEMY2> *E, vector<char> F, int *rest )
{
	int L = 0;
	*rest = 0;

	for ( int i=0; i<(int)E->size(); i++ )
	{
		ENEMY2 &e = (*E)[i];

		if ( e.state==1 && F[e.pos]=='g' )
		{
			e.state = 2;
			L--;
			*rest += e.life;
		}
	}

	return L;
}



//	G̃XebvƂ̏
void EnemyStep( vector<ENEMY2> *E )
{
	for ( int i=0; i<(int)E->size(); i++ )
	{
		ENEMY2 &e = (*E)[i];

		if ( e.state==1 )
		{
			e.age++;
			if ( e.freeze > 0 )
				e.freeze--;
			else
				e.count++;
		}
	}
}



//	̃XebvƂ̏
void TowerStep( vector<TOWER2> *T )
{
	for ( int i=0; i<(int)T->size(); i++ )
	{
		TOWER2 &t = (*T)[i];

		if ( t.count <= t.charge )
			t.count++;
	}
}
