#include "strategy.h"
#include "utility.h"
#include <ctime>




static vector<TOWER> FirstHalf( int stage, vector<char> F, vector<vector<ENEMY> > E );
static vector<TOWER> SecondHalf( int stage, vector<char> F, vector<vector<ENEMY> > E, bool file, int error );
static vector<TOWER> SecondHalf2( int stage, vector<char> F, vector<vector<ENEMY> > E );
static vector<TOWER> CreateMaze( vector<char> F, int *length, vector<TOWER> model );
static vector<ENEMY> CreateEnemy( int stage, vector<char> F );



//	Xe[W0p헪
vector<TOWER> BuildStage0( int level )
{
	switch ( level )
	{
	case 0:  return vector<TOWER>( 1, TOWER(3,3,3,0) );
	case 5:  return vector<TOWER>( 1, TOWER(3,3,4,0) );
	case 10: return vector<TOWER>( 1, TOWER(3,2,4,0) );
	default: return vector<TOWER>( 0 );
	}
}



//	Xe[W1ȍ~p헪
//	fileUȂt@C͓ǂ݂܂ȂiOvZpj
vector<TOWER> BuildTower( int stage, vector<char> F, bool file )
{
	vector<vector<ENEMY> > E = LoadEnemyFile( stage );

	if ( stage<40 )
	{
		if ( file )
		{
			vector<TOWER> T = LoadPlan( stage, F );

			//	svȓ̏
			int oLp = 0;
			int oM = 0;
			Simulate( stage, F, T, E, &oLp, &oM, false );

			vector<char> FF = LoadFieldFile( stage, 3 );

			for ( int i=0; i<(int)T.size(); i++ )
			if ( FF[T[i].p]=='2' )	//	_}XɌĂ铃̂ݒׂ
			{
				vector<TOWER> t = T;
				t.erase( t.begin()+i );
				int Lp = 0;
				int M = 0;
				Simulate( stage, F, t, E, &Lp, &M, false );

				//	ʂςȂ or ǂȂĂ΂̓폜
				if ( Lp>oLp ||
					 Lp==oLp && M>=oM )
				{
					T = t;
					oLp = Lp;
					oM = M;
					i--;
				}
			}

			return T;
		}
		else
		{
			return FirstHalf( stage, F, E );
		}
	}
	else
	{
		if ( file )
		{
			vector<TOWER> mT;

			int mLp = -100;
			int mM = -100000000;

			int error[] = {
				0,0,0,0,0,0,0,0,0,0,
				0,0,0,0,0,0,0,0,0,1,
				0,0,1,0,0,0,0,0,0,1,
				0,1,0,2,1,1,1,1,1,0,};

			for ( int i=0; i<6; i++ )
			//for ( int i=0; i<2; i++ )
			{
				vector<TOWER> T;
				if ( i==0 )
					T = LoadPlan( stage, F );
				else if ( i==1 )
					T = SecondHalf( stage, F, E, true, error[stage-40] );
				else
					T = SecondHalf( stage, F, E, false, error[stage-40] );

				//	ꂼV~[g
				int Lp = 0;
				int M = 0;

				Simulate( stage, F, T, E, &Lp, &M );
				
				Log( "Lp: %d, M: %d\n", Lp, M );
				
				if ( Lp>mLp ||
					 Lp==mLp && M>mM )
				{
					mT = T;
					mLp = Lp;
					mM = M;
				}
			}

			Log( "Stage %d, Lp %d, M %d\n\n", stage, mLp, mM );

			return mT;
		}
		else
		{
			//return SecondHalf2( stage, F, E );
			return SecondHalf( stage, F, E, false, stage<=100?0:1 );
		}
	}
}


template<class S,class T>
bool cmpfirst(pair<S,T> a,pair<S,T> b) { return a.first<b.first; }

static vector<TOWER> Tb;

static bool CanWin( int stage, vector<char> F, vector<TOWER> T, vector<ENEMY> E )
{
	int Lp = 1;
	Simulate( stage, F, T, vector<vector<ENEMY> >(1,E), &Lp, NULL );
	return Lp>0;
}

//	t1̓t2ɂ̂ɕKvȓԂ
static vector<TOWER> TowerDiff( vector<TOWER> t1, vector<TOWER> t2 )
{
	vector<TOWER> t;

	//	t1݂̂Ɋ܂܂铃
	for ( int i=0; i<(int)t1.size(); i++ )
	{
		bool f = false;
		for ( int j=0; j<(int)t2.size(); j++ )
			if ( t1[i].p == t2[j].p )
				f = true;
		if ( !f )
			t.push_back( TOWER( t1[i].p, 0, 3 ) );
	}

	//	t1Ɠł͂Ȃt2̓ǉ
	for ( int i=0; i<(int)t2.size(); i++ )
	{
		bool f = false;
		for ( int j=0; j<(int)t1.size(); j++ )
			if ( t1[j].p==t2[i].p && t1[j].a==t2[i].a && t1[j].c==t2[i].c )
				f = true;
		if ( !f )
			t.push_back( t2[i] );
	}

	return t;
}

vector<TOWER> BuildTowerFinalSub( int stage, vector<char> F, vector<ENEMY> E, vector<TOWER> Tb, bool *win, bool freeze, bool full );

//	p
vector<TOWER> BuildTowerFinal( int stage, vector<char> F, int level, vector<ENEMY> E, int Lp )
{
	Log( "Stage %d, level %d\n", stage, level );

	vector<TOWER> best;
	int bestLp = -99999999;
	clock_t start = clock();

	//	x0Ȃ瓃NA
	if ( level==0 )
		Tb.clear();

	for ( int i=0; ; i++ )
	{
		Log( "Build\n" );

		//	쐬@ȂO̓ɂ
		bool win;
		vector<TOWER> T = BuildTowerFinalSub( stage, F, E, i==0?Tb:vector<TOWER>(), &win, false, i>0 );
		if ( win )
		{
			Log( "OK\n" );
			//	ĂI
			best = T;
			break;
		}
		else
		{
			//	łǂzu
			int l = 0;
			Simulate( stage, F, T, vector<vector<ENEMY> >(1,E), &l, NULL, false );
			if ( l>bestLp )
			{
				bestLp = l;
				best = T;
			}

			Log( "NG Lp:%d\n", l );

			double t = (double)(clock()-start)/CLOCKS_PER_SEC;

			//	25bȏォ߂
			if ( t >= 25 )
			{
				Log( "Over 25s\n" );
				break;
			}

			//	Ct0ɂȂȂȂAb/5̃Ct͔F߂
			if ( Lp+l>0 && l >= -(int)(t/5) )
			{
				Log( "Lp %d, l %d\n", Lp, l );
				break;
			}
		}
	}

	Log( "Time %d ms\n", (clock()-start)*1000/CLOCKS_PER_SEC );

	vector<TOWER> Td = TowerDiff( Tb, best );
	Tb = best;
	return Td;
}

vector<TOWER> BuildTowerFinalSub( int stage, vector<char> F, vector<ENEMY> E, vector<TOWER> Tb, bool *win, bool freeze, bool full )
{
	*win = true;

	vector<TOWER> T;

	//	fɂȂ铃ΖH쐬
	if ( Tb.empty() )
	{
		Log( "Create Maze\n" );

		int len = 0;
		const int CM = 2;
		for ( int i=0; i<CM; i++ )
		{
			int l;
			vector<TOWER> t = CreateMaze( F, &l, vector<TOWER>() );
			Log( "Length: %d\n", l );
			if ( l>len )
				len = l,
				T = t;
		}

		//	KɃt[YɂĂ݂
		if ( freeze )
		{
			vector<char> f = F;
			for ( int i=0; i<(int)T.size(); i++ )
				f[T[i].p] = '1';
			vector<int> C = GetEnemyCourse( f, false );

			int g;	//	󂢂ĂS[
			for ( int i=0; i<SZ; i++ )
				if ( f[i]=='g' && C[i]>0 )
					g = i;

			for ( int i=0; i<(int)T.size(); i++ )
			if ( Distance2(T[i].p,g) <= 6*6 )
				if ( genrand_int31()%2 == 0 )
					T[i].a = 4,
					T[i].c = 2;
		}

		Log( "H: %d\n", T.size() );
	}
	else
	{
		T = Tb;
	}

	if ( ! CanWin( stage, F, T, E ) )
	{
		//	Ă܂œ
		const int R = 8;	//	x4̎˒

		//	̈ʒuQƂ݂Ȃ
		for ( int i=0; i<(int)T.size(); i++ )
			F[T[i].p] = '1';

		set<int> Tp;
		for ( int i=0; i<(int)T.size(); i++ )
			if ( T[i].a == 0 && T[i].c == 0 )
				Tp.insert( T[i].p );

		vector<int> C = GetEnemyCourse( F, false );
		vector<pair<int,int> > RT;	//	̎˒̓Gʂ}X

		for ( int p=0; p<(int)SZ; p++ )
		if ( ( F[p]=='0' || Tp.count(p)>0 ) && C[p]==0 )
		{
			int c = 0;
			for ( int y=p/W-R; y<=p/W+R; y++ )
			for ( int x=p%W-R; x<=p%W+R; x++ )
			if ( 0<=x && x<W && 0<=y && y<H &&
				 C[y*W+x]>0 && Distance2(p,y*W+x)<=R*R )
				c += C[y*W+x];

			RT.push_back( make_pair(c,p) );
		}

		random_shuffle(RT.begin(),RT.end());
		sort( RT.begin(), RT.end(), cmpfirst<int,int> );
		reverse( RT.begin(), RT.end() );

		int num = 0;
		int l = full ? (int)RT.size() : 0;
		int r = (int)RT.size();
		while ( r-l > 1 )
		{
			int m = (l+r)/2;

			vector<TOWER> t = T;

			for ( int i=0; i<m; i++ )
			{
				bool f = false;
				for ( int j=0; j<(int)t.size(); j++ )
					if ( t[j].p==RT[i].second )
						t[j].a = 4,
						f = true;
				if ( !f )
					t.push_back( TOWER(RT[i].second,4,0) );
			}
			
			if ( CanWin(stage,F,t,E) )
				r = m;
			else
				l = m;
		}

		for ( int i=0; i<r; i++ )
		{
			bool f = false;
			for ( int j=0; j<(int)T.size(); j++ )
				if ( T[j].p==RT[i].second )
					T[j].a = 4,
					f = true;
			if ( !f )
				T.push_back( TOWER(RT[i].second,4,0) );
		}

		//	SĂĂĂȂ(L֥M)
		if ( r==(int)RT.size() && !CanWin(stage,F,T,E) )
			*win = false;

		Log( "^ǉ: %d\n", r );
	}
	
	return T;
}



//	_~[̓G쐬
vector<ENEMY> CreateEnemy( int stage, vector<char> F )
{
	vector<int> S;
	for ( int i=0; i<SZ; i++ )
		if ( F[i]=='s' )
			S.push_back( i );

	vector<ENEMY> E;

	//for ( int i=0; i<2*(int)(sqrt((double)(stage+1)*25)*2+11); i++ )
	for ( int i=0; i<(int)(sqrt((double)(stage+1)*25)*2+11); i++ )
		E.push_back( ENEMY( S[i%S.size()], 1, (int)(pow((double)rand()/RAND_MAX,2)*2500*(stage+1)), 4 ) );
	
	return E;
}



//	OXe[W
vector<TOWER> FirstHalf( int stage, vector<char> F, vector<vector<ENEMY> > E )
{
	vector<TOWER> T;

	while ( true )
	{
		int INF = 100000000;

		//	ݒuÕCtȆ
		int oLp = INF;
		int oM = INF;
		Simulate( stage, F, T, E, &oLp, &oM );
		oLp -= INF;
		oM -= INF;

		//	œKȐݒuꏊ߂
		int mLp = -INF;
		int mM = -INF;
		vector<TOWER> mt;

		//	ST
		for ( int p=0; p<SZ; p++ )
		for ( int a=0; a<=4; a++ )
		{
			//	Ă邩`FbN
			if ( F[p]!='0' )
				continue;

			F[p] = '1';
			int f = GetEnemyCourseLength( F );
			F[p] = '0';
			if ( f==0 )
				continue;

			//	V~[g
			int Lp = INF;
			int M = INF;
			T.push_back( TOWER(p,a,0) );
			Simulate( stage, F, T, E, &Lp, &M );
			T.pop_back();
			Lp -= INF;
			M -= INF;

			if ( Lp > mLp  ||
				 Lp == mLp && M > mM )
			{
				mLp = Lp;
				mM = M;
				mt.clear();
			}
			if ( Lp==mLp && M==mM )
			{
				mt.push_back( TOWER(p,a,0) );
			}
		}

		if ( mLp==-INF )
			break;

		//	Ct炸AǂȂꏊȂI
		if ( oLp==0 &&
			( mLp<oLp || mLp==oLp && mM<=oM ) )
			break;

		//	ݒu
		int rt = genrand_int31()%mt.size();
		T.push_back( mt[rt] );
		F[mt[rt].p] = '1';
		Log( "ݒu: %d, %d, %d, %d, %d\n", mt[rt].p%W, mt[rt].p/W, mt[rt].a, mLp, mM );
	}

	Log( ": %d\n", T.size() );
	
	return T;

}





//	㔼Xe[W
vector<TOWER> SecondHalf( int stage, vector<char> F, vector<vector<ENEMY> > E, bool file, int error )
{
	//	H쐬
	Log( "Create Maze\n" );

	vector<TOWER> model;
	if ( file )
	{
		model = LoadPlan( stage, F );
		//	Sx0
		for ( int i=0; i<(int)model.size(); i++ )
			model[i].a = 0;
	}

	int len = 0;
	vector<TOWER> T;
	const int CM = 1;
	for ( int i=0; i<CM; i++ )
	{
		int l;
		vector<TOWER> t = CreateMaze( F, &l, model );
		Log( "Length: %d\n", l );
		if ( l>len )
			len = l,
			T = t;
	}

	Log( "H: %d\n", T.size() );

	const int R = 8;	//	x4̎˒

	//	̈ʒuQƂ݂Ȃ
	for ( int i=0; i<(int)T.size(); i++ )
		F[T[i].p] = '1';

	set<int> Tp;
	for ( int i=0; i<(int)T.size(); i++ )
		Tp.insert( T[i].p );

	vector<int> C = GetEnemyCourse( F, false );
	vector<pair<int,int> > RT;	//	̎˒̓Gʂ}X

	for ( int p=0; p<(int)SZ; p++ )
	if ( ( F[p]=='0' || Tp.count(p)>0 ) && C[p]==0 )
	{
		int c = 0;
		for ( int y=p/W-R; y<=p/W+R; y++ )
		for ( int x=p%W-R; x<=p%W+R; x++ )
		if ( 0<=x && x<W && 0<=y && y<H &&
			 C[y*W+x]>0 && Distance2(p,y*W+x)<=R*R )
			c += C[y*W+x];

		RT.push_back( make_pair(c,p) );
	}

	random_shuffle(RT.begin(),RT.end());
	sort( RT.begin(), RT.end(), cmpfirst<int,int> );
	reverse( RT.begin(), RT.end() );

	//	Ă܂œ
	int num = 0;
	int l = 0;
	int r = (int)RT.size();
	while ( r-l > 1 )
	{
		int m = (l+r)/2;

		vector<TOWER> t = T;

		for ( int i=0; i<m; i++ )
		{
			bool f = false;
			for ( int j=0; j<(int)t.size(); j++ )
				if ( t[j].p==RT[i].second )
					t[j].a = 4,
					f = true;
			if ( !f )
				t.push_back( TOWER(RT[i].second,4,0) );
		}
			
		int Lp = error+1;
		Simulate( stage, F, t, E, &Lp, NULL );
		if ( Lp >= 1 )
			r = m;
		else
			l = m;
	}

	for ( int i=0; i<r; i++ )
	{
		bool f = false;
		for ( int j=0; j<(int)T.size(); j++ )
			if ( T[j].p==RT[i].second )
				T[j].a = 4,
				f = true;
		if ( !f )
			T.push_back( TOWER(RT[i].second,4,0) );
	}

	Log( "^ǉ: %d\n", r );

	return T;
}



//	㔼Xe[Wǔ
vector<TOWER> SecondHalf2( int stage, vector<char> F, vector<vector<ENEMY> > E )
{
	//	H쐬
	Log( "Create Maze\n" );

	vector<TOWER> model = LoadPlan( stage, F );
	//	Sx0
	for ( int i=0; i<(int)model.size(); i++ )
		model[i].a = 0;

	int len = 0;
	vector<TOWER> T;
	const int CM = 16;
	for ( int i=0; i<CM; i++ )
	{
		int l;
		//vector<TOWER> t = CreateMaze( F, &l, vector<TOWER>() );
		vector<TOWER> t = CreateMaze( F, &l, model );
		Log( "Length: %d\n", l );
		if ( l>len )
			len = l,
			T = t;
	}

	Log( "H: %d\n", T.size() );

	//	G̃R[XvZ
	vector<char> Ft = F;
	for ( int i=0; i<(int)T.size(); i++ )
		Ft[T[i].p] = '1';
	vector<int> C = GetEnemyCourse( Ft, false );

	//	Ă܂œEǉ
	int num = 0;

	int Lp = 1;
	Simulate( stage, F, T, E, &Lp, NULL );

	if ( Lp<=0 )
	while ( true )
	{
		const int INF = 100000000;
		int mr = INF;
		vector<TOWER> mt;
		int mp;

		for ( int p=0; p<SZ; p++ )
		if ( F[p]=='0' && C[p]==0 )
		{
			vector<TOWER> t = T;
			bool f = false;
			for ( int i=0; i<(int)t.size(); i++ )
				if ( t[i].p==p )
					t[i].a = 4,
					f = true;
			if ( !f )
				t.push_back( TOWER(p,4,0) );

			int Lp = 0;
			int rest;
			Simulate( stage, F, t, E, &Lp, NULL, false, &rest );
			if ( rest < mr )
				mr = rest,
				mt = t,
				mp = p;
		}
		
		if ( mr==INF )
		{
			Log( "ĂȂ(L֥M)\n" );
			break;
		}

		T = mt;
		F[mp] = '1';
		num++;
		if ( mr == 0 )
			break;
		Log("|");
	}

	Log("\n");
	Log( "^ǉ: %d\n", num );

	return T;

}


//	H쐬
vector<TOWER> CreateMaze( vector<char> F, int *length, vector<TOWER> model=vector<TOWER>() )
{
	vector<TOWER> T = model;

	//	̈ʒu1ɂ
	for ( int i=0; i<(int)T.size(); i++ )
		F[T[i].p] = '1';
	
	//	ǂS[߂
	vector<int> G;
	for ( int i=0; i<SZ; i++ )
		if ( F[i]=='g' )
			G.push_back( i );

	int rg = genrand_int31()%G.size();
	
	for ( int i=0; i<4; i++ )
	{
		//	PȊÕS[ǂ
		if ( model.empty() )
		{
			for ( int i=0; i<(int)G.size(); i++ )
			if ( i!=rg )
			{
				for ( int d=0; d<8; d+=2 )
				{
					int t = G[i]+Dir[d];
					if ( F[t]=='0' )
					{
						T.push_back( TOWER(t,0,0) );
						F[t]='1';
					}
				}
			}

			//	̎_œBs\ɂȂ邱Ƃ肦
			//	̏ꍇ̓S[ǂȂ
			if ( GetEnemyCourseLength(F) == 0 )
			{
				for ( int i=0; i<(int)T.size(); i++ )
					F[T[i].p] = '0';
				T.clear();
			}
		}

		//	oH𒷂Ă
		vector<bool> W(SZ);		//	ɓzuƍǂł܂

		while ( true )
		{
			vector<int> C = GetEnemyCourse( F, true );

			int m = -1;
			vector<TOWER> mt;

			for ( int p=0; p<SZ; p++ )
			if ( F[p]=='0' && C[p]>0 && !W[p] )
			{
				F[p] = '1';
				int l = GetEnemyCourseLength( F );
				F[p] = '0';

				if ( l == 0 )
				{
					W[p] = true;
					continue;
				}
				
				if ( l>m )
					mt.clear(),
					m = l;
				if ( l==m )
					mt.push_back( TOWER(p,0,0) );
			}

			if ( m==-1 )
				break;

			int rt = genrand_int31()%mt.size();
			T.push_back( mt[rt] );
			F[mt[rt].p] = '1';

			////	\
			//for ( int y=0; y<H; y++ )
			//	cout << string(F.begin()+y*W,F.begin()+y*W+W) << endl;
			//cout << endl;
		}

		*length = GetEnemyCourseLength( F );

		//	svȓ

		int rm = 0;

		random_shuffle(T.begin(),T.end());

		for ( int i=0; i<(int)T.size(); )
		{
			F[T[i].p] = '0';
			int l = GetEnemyCourseLength(F);
			F[T[i].p] = '1';

			if ( l==*length )
			{
				F[T[i].p] = '0';
				T.erase(T.begin()+i);
				rm++;

			}
			else
				i++;
		}

		//if ( rm == 0)
		//	break;
	}

	return T;
}
